(* [] *)

Program Viergewinnt;

(* --------------------------------------------------- *)
(* 4/93-9/93 by Michael Wessel, MW-Soft! 19.9.1993     *)
(* Thanks to Malte Woydt for "strategical assistance"! *)
(* --------------------------------------------------- *)

{$incl "graphics.lib", "intuition/intuitionbase.h",
       "intuition/intuition.h", "intuition.lib"}

(* Konstante und Variablen *)

const ymax     = 6;
      xmax     = 7;
      maxlevel = 2;
      info     = true;

type spielbrett = array[1..xmax,0..ymax]        of integer;
     bewertung  = array[0..2,0..xmax]           of integer;
     rfeld      = array[0..maxlevel+1,-1..xmax] of integer;
     zugmem     = array[1..xmax*ymax]           of integer;

var feld    : spielbrett;
    zugmemx : zugmem;
    zugmemy : zugmem;
    bewe    : bewertung;
    ellbuff : array[1..20] of byte;
    tribuff : array[1..25] of byte;

    ende, flag, err, demo : boolean;

    yl, lzug, knopf, funktion, y, fertig, dx, dy   : integer;
    zug, i, ii, spieler, zugzaehl, werzieht, level : integer;

    Win  : ^Window;
    IWin : ^Window;
    Rp   : ^RastPort;
    IRp  : ^RastPort;
    Msg  : ^IntuiMessage;
    Vp   : ^ViewPort;
    plane: Ptr;

    TRas            : TmpRas;
    AEllInf, ATriInf: AreaInfo;

(* Textausgabe-Routine *)

procedure text(Rp: Ptr; text: string; var line : integer; farbe : integer);

var err : boolean;

begin

  SetDrMd(Rp,JAM1);

  Move(Rp,2,line+1);
  SetAPen(Rp,3);
  if (farbe=3) then SetAPen(Rp,2);
  err:=GfxText(Rp,text,StrLen(text));

  Move(Rp,0,line);
  SetAPen(Rp,farbe);
  err:=GfxText(Rp,text,StrLen(text));

  line:=line+8;

end;

(* Textausgabe-Routine *)

procedure gtext(Rp: Ptr; text: string; x, y, farbe, hfarbe : integer);

var err : boolean;

begin

  SetDrMd(Rp,JAM1);

  Move(Rp,x+3,y+2);
  SetAPen(Rp,hfarbe);
  err:=GfxText(Rp,text,StrLen(text));

  Move(Rp,x,y);
  SetAPen(Rp,farbe);
  err:=GfxText(Rp,text,StrLen(text));

end;

(* Bedienungselemente zeichnen *)

procedure faerbe(dx, dy, knopf, funktion, farbe : integer);

var fa, x, y, ofx, ofy, gx, gy, rx, ry : integer;

begin

  if (knopf=0) and (funktion=0) then exit;

  ofx:=dx div 4;
  ofy:=dy div 7;
  rx:=round((dx-ofx-30)/8*3/8);
  ry:=round((dy-ofy-23)/7*3/8);

  SetAPen(Rp,farbe);

  if (knopf>0) and (knopf<8) then begin
    gx:=round(ofx+knopf*(dx-ofx-30)/8);
    SetAPen(Rp,farbe);
    Flood(Rp,1,gx,(ofy div 5)+ry);
  end;

  if (funktion>0) and (funktion<7) then begin
    gy:=round(ofy+funktion*(dy-ofy-23)/7);
    SetAPen(Rp,3);
    RectFill(Rp,round(ofx/5),gy-ry+2,round(ofx*4/5)+3,gy+ry+2);
    SetAPen(Rp,farbe);
    RectFill(Rp,round(ofx/5) -3,gy-ry,round(ofx*4/5),gy+ry)

    x:=round(ofx*5/10)-26;
    y:=gy+round(ry/3);
    if (farbe=2) then fa:=0;
    if (farbe=1) then begin farbe:=3; fa:=2; end;

    case funktion of
      1 : GText(Rp," Move ",x,y,3-farbe,fa);
      2 : GText(Rp," Back ",x,y,3-farbe,fa);
      3 : GText(Rp," <--> ",x,y,3-farbe,fa);
      4 : GText(Rp," New! ",x,y,3-farbe,fa);
      5 : GText(Rp," Demo ",x,y,3-farbe,fa);
      6 : GText(Rp," Info ",x,y,3-farbe,fa);
    end;
  end;

end;

(* Farbwechsel *)

procedure wechsel(dx,dy : integer; var werzieht : integer);

var ofx, ofy, rx, ry : integer;

begin

  werzieht:=3-werzieht;

  ofx:=dx div 4;
  ofy:=dy div 7;
  rx:=round((dx-ofx-30)/8*3/8);
  ry:=round((dy-ofy-23)/7*3/8);

  SetAPen(Rp,3);
  AreaEllipse(Rp,ofx div 2 +3,round(ofy*2/3)+2,rx,ry);
  AreaEnd(Rp);

  SetAPen(Rp,werzieht);
  Rp^.AreaInfo:=^AEllInf;
  AreaEllipse(Rp,ofx div 2,round(ofy*2/3),rx,ry);
  AreaEnd(Rp);

end;

(* auf Messages warten *)

procedure warte(UPort: Ptr; var i, ii : integer);

var Msg: ^IntuiMessage;

begin

  i:=0;
  ii:=0;

  Msg:=Wait_Port(UPort);
  Msg:=Get_Msg(UPort);
  Reply_Msg(Msg);

  if (Msg^.Class=MOUSEBUTTONS) then
    if (Msg^.Code and $80)=0 then
      if (Msg^.Code and $01)=0 then begin
        i:=Msg^.MouseX-2;
        ii:=Msg^.MouseY-12;
  end;

end;

(* Bedienung *)

procedure mausknopf(x, y, dx, dy : integer; var knopf, funktion : integer);

var ofx, ofy, rx, ry, gx, gy, i, ii : integer;

begin

  y:=y-12;
  x:=x-2;
  ofx:=dx div 4;
  ofy:=dy div 7;
  rx:=round((dx-ofx-30)/8*3/8);
  ry:=round((dy-ofy-23)/7*3/8);

  knopf:=0;

  for i:=1 to 7 do begin
    gx:=round(ofx+i*(dx-ofx-30)/8);
    if (x>gx-rx) and (x<gx+rx) and
       (y>ofy div 5) and (y<(ofy div 5)+2*ry) then begin
      knopf:=i;
      ii:=gx;
    end;
  end;

  if (knopf>0) then faerbe(dx,dy,knopf,0,1);

  funktion:=0;

  for i:=1 to 6 do begin
    gy:=round(ofy+i*(dy-ofy-23)/7);
    if (x>ofx div 5 -3) and (x<round(ofx*4/5)) and
       (y>gy-ry) and (y<gy+ry) then begin
         funktion:=i;
         ii:=gy;
    end;
  end;

  if (funktion>0) then faerbe(dx,dy,0,funktion,1);

end;

(* Spielbrett etc. zeichnen *)

procedure brett(feld : spielbrett; dx, dy : integer);

var ofx, ofy, rx, ry, gx, gy, x, y : integer;

begin

  ofx:=dx div 4;
  ofy:=dy div 7;
  rx:=round((dx-ofx-30)/8*3/8);
  ry:=round((dy-ofy-23)/7*3/8);

  SetRast(Rp,0);
  SetAPen(Rp,1);
  RectFill(Rp,ofx+4,ofy+2,dx-26,dy-21);

  SetAPen(Rp,2);
  RectFill(Rp,ofx,ofy,dx-30,dy-23);
  SetAPen(Rp,3);
  RectFill(Rp,ofx+4,ofy+2,dx-34,dy-25);

  for x:=1 to 7 do begin
    gx:=round(ofx+x*(dx-ofx-30)/8);

    Rp^.AreaInfo:=^ATriInf;
    SetAPen(Rp,3);
    AreaMove(Rp,gx-rx,ofy div 5);
    AreaDraw(Rp,gx+rx,ofy div 5);
    AreaDraw(Rp,gx,(ofy div 5)+2*ry);
    AreaEnd(Rp);

    SetAPen(Rp,2);
    AreaMove(Rp,gx-rx+(rx div 2),(ofy div 5)+(ry div 2));
    AreaDraw(Rp,gx+rx-(rx div 2),(ofy div 5)+(ry div 2));
    AreaDraw(Rp,gx,(ofy div 5)+2*ry-(ry div 2));
    AreaEnd(Rp);

    Rp^.AreaInfo:=^AEllInf;

    for y:=1 to 6 do begin
      gy:=round(ofy+y*(dy-ofy-23)/7);
      if (x=1) then faerbe(dx,dy,0,y,2);
      SetAPen(Rp,0);
      AreaEllipse(Rp,gx,gy,rx,ry);
      AreaEnd(Rp);
      SetAPen(Rp,feld[x,7-y]);
      if (feld[x,7-y]<>0) then begin
        AreaEllipse(Rp,gx,gy,rx-1,ry-1);
        AreaEnd(Rp);
      end;
    end;
  end;

end;

(* Stein darstellen *)

procedure zeigestein(dx, dy, x, y, farbe : integer);

var ofx, ofy, rx, ry, gx, gy : integer;

begin

  y:=7-y;
  ofx:=dx div 4;
  ofy:=dy div 7;
  rx:=round((dx-ofx-30)/8*3/8);
  ry:=round((dy-ofy-23)/7*3/8);
  gx:=round(ofx+x*(dx-ofx-30)/8);
  gy:=round(ofy+y*(dy-ofy-23)/7);

  Rp^.AreaInfo:=^AEllInf;
  SetAPen(Rp,farbe);
  AreaEllipse(Rp,gx,gy,rx-1,ry-1);
  AreaEnd(Rp);

end;

(* Stein einwerfen *)

function ziehe(var feld : spielbrett; zug, werzieht : integer):integer;

var y : integer;

begin

  y:=feld[zug,0];
  if (y=ymax) then ziehe:=0
  else begin
    inc(feld[zug,0]);
    feld[zug,y+1]:=werzieht;
    ziehe:=y+1;
  end;

end;

(* Stein entnehmen *)

procedure entnehme(var feld : spielbrett; zug : integer);

var y : integer;

begin

  y:=feld[zug,0];
  if (y>0) then begin
    dec(feld[zug,0]);
    feld[zug,y]:=0;
  end;

end;

(* Maximum-Funktion *)

function max(a, b : integer):integer;

begin
  if (a>b) then max:=a else max:=b;
end;

(* Minimum-Funktion *)

function min(a, b : integer):integer;

begin
  if (a>b) then min:=b else min:=a;
end;

(* Punkte vergeben *)

procedure punkte(var summe : integer; anz, tanz, frei, setz : integer);

begin

  case tanz of
    0 : ;
    1 : if (frei>2) then summe:=summe+(anz+frei+setz   );
    2 : if (frei>1) then summe:=summe+(anz+frei+setz+15);
  otherwise
        if (frei>0) then summe:=summe+(anz+frei+setz+70);
  end;

end;

(* Situationsbewertung, lokale Brettanalyse um einen Punkt (ix,iy) *)

procedure suche(var summe  : integer; var dreier : integer;
                var vierer : boolean; ix, iy     : integer;
                var feld   : spielbrett; typ     : integer);

var stein, t, z, dreix, dreiy, z1, z2  : integer;
    last, lastd1, lastd2               : integer;
    dreid1, dreid2                     : integer;
    tsumx, tsumd1,        tsumd2       : integer;
    sumx,  sumy,  sumd1,  sumd2        : integer;
    freix, freiy, freid1, freid2       : integer;
    sable, d1sable,       d2sable      : integer;
    tsable, td1sable,    td2sable      : integer;
    s1, s2, s1d1, s2d1, s1d2, s2d2     : integer;
    dazx, dazd1,dazd2                  : integer;
    tdazx, tdazd1, tdazd2              : integer;
    flag1, flag2, flag3, flag4         : boolean;
    sp1flag, sp2flag, spxflag          : boolean;
    sp1d1flag, sp2d1flag, spd1flag     : boolean;
    sp1d2flag, sp2d2flag, spd2flag     : boolean;
    d1flag1, d1flag2, d2flag1, d2flag2 : boolean;
    d1flag3, d2flag3, d1flag4, d2flag4 : boolean;
    flag2x, flag2d1, flag2d2           : boolean;

begin

  (* Horizontale *)

  flag1:=true; flag2:=true;
  flag3:=true; flag4:=true;

  sumx  :=0; tsumx:=0;
  freix :=0; last :=-1;
  dazx  :=0; tdazx:=0;
  tsable:=0; s1   :=0;

  sp1flag:=false; flag2x:=false;

  for t:=ix to xmax do begin

    stein:=feld[t,iy];
    if (stein=typ) then begin
      if (last=t-1) then flag2x:=true;
      if flag1 then inc( sumx);  (* zusammenhngende Eigene ab ix *)
      if flag2 then inc(tsumx); (* alle Eigenen, nur leere dazwischen *)
      if (not flag1) and flag2 and flag4 then begin
        if flag3 then dazx:=s1;
        tdazx:=freix;
        flag4:=false;
      end;
      last:=t;
    end
    else begin
      flag1:=false;
      if (stein=3-typ) then flag2:=false;
      if (stein=0) and flag2 then begin
        inc(freix); (* alle eigenen Leerstellen *)
        if (iy=1) or ((iy>1) and (feld[t,iy-1]<>0)) then begin
          inc(tsable); (* setzbare Positionen *)
          if flag3 then begin inc(s1); sp1flag:=true; end; (* zus. setzb. *)
        end
        else flag3:=false;
      end;
    end;
  end;

  flag1:=true; flag2:=true; flag3:=true; flag4:=true;
  sp2flag:=false; last:=-1; s2:=0; z:=freix;

  for t:=ix downto 1 do begin

    stein:=feld[t,iy];
    if (stein=typ) then begin
      if (last=t+1) then flag2x:=true;
      if flag1 then inc( sumx);
      if flag2 then inc(tsumx);
      if (not flag1) and flag2 and flag4 then begin
        if ( dazx<>1) and flag3 then  dazx:=s2;
        if (tdazx<>1)           then tdazx:=freix-z;
        flag4:=false;
      end;
      last:=t;
    end
    else begin
      flag1:=false;
      if (stein=3-typ) then flag2:=false;
      if (stein=0) and flag2 then begin
        inc(freix);
        if (iy=1) or ((iy>1) and (feld[t,iy-1]<>0)) then begin
          inc(tsable);
          if flag3 then begin inc(s2); sp2flag:=true; end;
        end
        else flag3:=false;
      end;
    end;
  end;

  if (sumx>0) then begin dec(sumx); dec(tsumx); end;
  if (sumx=0) and (freix>0) then dec(freix);
  spxflag:=sp1flag and sp2flag;
  sable:=s1+s2;

  (* Vertikale *)

  flag1:=true; flag2:=true;
  sumy :=0;    freiy:=0;

  for t:=iy to ymax do begin

    stein:=feld[ix,t];
    if (stein=typ) and flag1 then
      inc(sumy)
    else begin
      flag1:=false;
      if (stein=0) and flag2 then inc(freiy) else flag2:=false;
    end;
  end;

  flag1:=true;

  for t:=iy downto 1 do begin

    stein:=feld[ix,t];
    if (stein=typ) and flag1 then inc(sumy) else flag1:=false;
  end;

  if (sumy>0) then dec(sumy);
  if (sumy=0) and (freiy>0) then dec(freiy);

  (* Diagonalen *)

  d1flag1:=true; d2flag1:=true;
  d1flag2:=true; d2flag2:=true;
  d1flag3:=true; d2flag3:=true;
  d1flag4:=true; d2flag4:=true;

  sp1d1flag:=false; sp2d1flag:=false;
  sp1d2flag:=false; sp2d2flag:=false;
  flag2d1  :=false; flag2d2  :=false;

  tsumd1  :=0;  tsumd2  :=0;
  sumd1   :=0;  sumd2   :=0;
  freid1  :=0;  freid2  :=0;
  td1sable:=0;  td2sable:=0;
  s1d1    :=0;  s2d1    :=0;
  s1d2    :=0;  s2d2    :=0;
  dazd1   :=0;  dazd2   :=0;
  tdazd1  :=0;  tdazd2  :=0;
  lastd1  :=-1; lastd2  :=-1;

  for t:=iy to max(xmax,ymax) do begin

    if (t<=ymax) and ((t-iy+ix)<=xmax) then begin
      stein:=feld[ix+t-iy,t];
      if (stein=typ) then begin
        if (lastd1=t-1) then flag2d1:=true;
        if d1flag1 then inc( sumd1);
        if d1flag2 then inc(tsumd1);
        if (not d1flag1) and d1flag2 and d1flag4 then begin
          if d1flag3 then dazd1:=s1d1;
          tdazd1:=freid1;
          d1flag4:=false;
        end;
        lastd1:=t;
      end
      else begin
        d1flag1:=false;
        if (stein=3-typ) then d1flag2:=false;
        if (stein=0) and d1flag2 then begin
          inc(freid1);
          if (t=1) or ((t>1) and (feld[ix+t-iy,t-1]<>0)) then begin
            inc(td1sable);
            if d1flag3 then begin inc(s1d1); sp1d1flag:=true; end;
          end
          else d1flag3:=false;
        end;
      end;
    end;

    if (t<=ymax) and ((ix-t+iy)>=1) then begin
      stein:=feld[ix-t+iy,t];
      if (stein=typ) then begin
        if (lastd2=t-1) then flag2d2:=true;
        if d2flag1 then inc( sumd2);
        if d2flag2 then inc(tsumd2);
        if (not d2flag1) and d2flag2 and d2flag4 then begin
          if d2flag3 then dazd2:=s1d2;
          tdazd2:=freid2;
          d2flag4:=false;
        end;
        lastd2:=t;
      end
      else begin
        d2flag1:=false;
        if (stein=3-typ) then d2flag2:=false;
        if (stein=0) and d2flag2 then begin
          inc(freid2);
          if (t=1) or ((t>1) and (feld[ix-t+iy,t-1]<>0)) then begin
            inc(td2sable);
            if d2flag3 then begin inc(s1d2); sp1d2flag:=true; end;
          end
          else d2flag3:=false;
        end;
      end;
    end;
  end;

  d1flag1:=true; d2flag1:=true;
  d1flag2:=true; d2flag2:=true;
  d1flag3:=true; d2flag3:=true;
  d1flag4:=true; d2flag4:=true;

  lastd1:=-1; z1:=freid1;
  lastd2:=-1; z2:=freid2;

  for t:=iy downto 1 do begin

    if ((ix+t-iy)>=1) then begin
      stein:=feld[ix+t-iy,t];
      if (stein=typ) then begin
        if (lastd1=t+1) then flag2d1:=true;
        if d1flag1 then inc( sumd1);
        if d1flag2 then inc(tsumd1);
        if (not d1flag1) and d1flag2 and d1flag4 then begin
          if ( dazd1<>1) and d1flag3 then dazd1:=s2d1;
          if (tdazd1<>1)             then tdazd1:=freid1-z1;
          d1flag4:=false;
        end;
        lastd1:=t;
      end
      else begin
        d1flag1:=false;
        if (stein=3-typ) then d1flag2:=false;
        if (stein=0) and d1flag2 then begin
          inc(freid1);
          if (t=1) or ((t>1) and (feld[ix+t-iy,t-1]<>0)) then begin
            inc(td1sable);
            if d1flag3 then begin inc(s2d1); sp2d1flag:=true; end;
          end
          else d1flag3:=false;
        end;
      end;
    end;

    if ((ix-t+iy)<=xmax) then begin
      stein:=feld[ix-t+iy,t];
      if (stein=typ) then begin
        if (lastd2=t+1) then flag2d2:=true;
        if d2flag1 then inc( sumd2);
        if d2flag2 then inc(tsumd2);
        if (not d2flag1) and d2flag2 and d2flag4 then begin
          if ( dazd2<>1) and d2flag3 then  dazd2:=s2d2;
          if (tdazd2<>1)             then tdazd2:=freid2-z2;
          d2flag4:=false;
        end;
        lastd2:=t;
      end
      else begin
        d2flag1:=false;
        if (stein=3-typ) then d2flag2:=false;
        if (stein=0) and d2flag2 then begin
          inc(freid2);
          if (t=1) or ((t>1) and (feld[ix-t+iy,t-1]<>0)) then begin
            inc(td2sable);
            if d2flag3 then begin inc(s2d2); sp2d2flag:=true; end;
          end
          else d2flag3:=false;
        end;
      end;
    end;
  end;

  if (sumd1>0) then begin dec(sumd1); dec(tsumd1); end;
  if (sumd2>0) then begin dec(sumd2); dec(tsumd2); end;

  if (sumd1=0) and (freid1>0) then dec(freid1);
  if (sumd2=0) and (freid2>0) then dec(freid2);

  spd1flag:=sp1d1flag and sp2d1flag;
  spd2flag:=sp1d2flag and sp2d2flag;

  d1sable:=s1d1+s2d1;
  d2sable:=s1d2+s2d2;

  (* Punkte vergeben, auswerten *)

  summe:=0;
  vierer:=false;
  if (sumx>3) or (sumy>3) or (sumd1>3) or (sumd2>3) then vierer:=true;

  dreier:=0;
  flag1:=false; flag2:=false; flag3:=false;

  if not vierer then begin
    dreix:=0; dreiy:=0; dreid1:=0; dreid2:=0;

    punkte(summe,sumx,tsumx,freix,sable);
    punkte(summe,sumy,sumy,freiy,freiy);
    punkte(summe,sumd1,tsumd1,freid1,d1sable);
    punkte(summe,sumd2,tsumd2,freid2,d2sable);

    (* Dreierkennungen vergeben *)

    if (tsumx>=3) then begin
      if (freix>=1) then begin
        if flag2x and (tdazx=1) then dreix:=2;
        if (sumx=3) then if (sable>0) then dreix:=1 else dreix:=2;
        if flag2x and (dazx=1)  then dreix:=1;
        if (sumx=3) and spxflag then flag1:=true;
      end
      else dreix:=3;
    end;

    if (sumy=3) then begin
      if (freiy>=1) then dreiy:=1 else dreiy:=3;
    end;

    if (tsumd1>=3) then begin
      if (freid1>=1) then begin
        if flag2d1 and (tdazd1=1) then dreid1:=2;
        if (sumd1=3) then if (d1sable>0) then dreid1:=1 else dreid1:=2;
        if flag2d1 and (dazd1=1)  then dreid1:=1;
        if (sumd1=3) and spd1flag then flag2:=true;
      end
      else dreid1:=3;
    end;

    if (tsumd2>=3) then begin
      if (freid2>=1) then begin
        if flag2d2 and (tdazd2=1) then dreid2:=2;
        if (sumd2=3) then if (d2sable>0) then dreid2:=1 else dreid2:=2;
        if flag2d2 and (dazd2=1)  then dreid2:=1;
        if (sumd2=3) and spd2flag then flag3:=true;
      end
      else dreid2:=3;
    end;

    (* Dreier-Codierung: -1 : keiner, 1 : Zugzwang f. Gegner, 2 : setzbar,
                          3 : nicht vervollstndigbar,        0 : Zwickmhle,
                          4 : Horizontal-Zwickmhle *)
    dreier:=-1;
    if (dreix=3) or (dreiy=3) or (dreid1=3) or (dreid2=3) then dreier:=3;
    if (dreix=2) or (dreiy=2) or (dreid1=2) or (dreid2=2) then dreier:=2;
    if (dreix=1) or (dreiy=1) or (dreid1=1) or (dreid2=1) then begin
      if (dreix<>1)  then dreix:=0;
      if (dreiy<>1)  then dreiy:=0;
      if (dreid1<>1) then dreid1:=0;
      if (dreid2<>1) then dreid2:=0;

      if (dreix+dreiy+dreid1+dreid2>1) then dreier:=0 else dreier:=1;
      if (dreier<>0) and (flag1 or flag2 or flag3) then dreier:=4;
    end;
  end;

end;

(* zentraler Aufruf der Such-Funktionen *)

procedure bewerte(var summe  : integer; var dreier : integer;
                  var vierer : boolean; ix, iy     : integer;
                  var feld   : spielbrett; typ     : integer);

var a, b, dreier2 : integer;
    vierer2       : boolean;

begin

  suche(summe,dreier,vierer,ix,iy,feld,typ);
  if (iy<ymax) and not((dreier=1) or (dreier=0) or (dreier=4) or vierer) then begin
    feld[ix,iy+1]:=typ;
    feld[ix,iy  ]:=3-typ;
    suche(b,dreier2,vierer2,ix,iy+1,feld,typ);
    feld[ix,iy  ]:=typ;
    feld[ix,iy+1]:=0;
    if vierer2 then dreier:=1;
  end;

end;

(* Ist das Spiel beendet ? *)

function ready(var feld : spielbrett):integer;

var summe, dreier, typ, fertig, typ, x, y : integer;
    vierer, flag                          : boolean;

begin

  fertig:=0;
  vierer:=false;

  for typ:=1 to 2 do
    for x:=1 to xmax do
      for y:=1 to ymax do begin
        suche(summe,dreier,vierer,x,y,feld,typ);
        if vierer then fertig:=typ;
  end;

  if (fertig=0) then begin
    flag:=true;
    for x:=1 to xmax do
      if (feld[x,ymax]=0) then flag:=false;
    if flag then ready:=3 else ready:=fertig;
  end
  else
    ready:=fertig;

end;

(* rekursive Zuganalyse, Backtracking-Verfahren *)

procedure denke(level    : integer;    phase    : integer;   ac  : integer;
                var feld : spielbrett; var bewe : bewertung; typ : integer);

var dreier, x, y, psumme : integer;
    vierer               : boolean;

begin

  for x:=1 to xmax do begin
    y:=ziehe(feld,x,typ);
    if (y<>0) then begin
      bewerte(psumme,dreier,vierer,x,y,feld,typ);
      if (phase=0) then begin
        ac:=x;
        bewe[1,ac]:=psumme;
        bewe[2,ac]:=0;
        bewe[0,ac]:=dreier;
      end;
      if vierer then
        if ((bewe[2,ac]>phase+1) or (bewe[2,ac]=0)) then
          bewe[2,ac]:=phase+1;
      if (phase<>level) and not (vierer and (phase=0)) then
        denke(level,phase+1,ac,feld,bewe,typ);
      entnehme(feld,x);
      end
    else begin
      if (phase=0) then begin
        bewe[1,x]:=-1;
        bewe[2,x]:=0;
      end;
    end;
  end;

end;

(* Parallel-Dreier vorhanden? *)

function vorpardreier(feld : spielbrett, x, wer : integer):boolean;

var summe, dreier, y : integer;
    vierer, avierer  : boolean;

begin

  avierer:=false;
  vorpardreier:=false;
  y:=ziehe(feld,x,wer);
  if (y<>0) then begin
    entnehme(feld,x);
    for y:=y to ymax do begin
      feld[x,y]:=wer;
      suche(summe,dreier,vierer,x,y,feld,wer);
      if vierer and avierer then vorpardreier:=true;
      feld[x,y]:=0;
      avierer:=vierer;
    end;
  end;

end;

(* Problem der parallelen, offenen Dreier *)

function pardreier(feld : spielbrett; wer, x, y : integer):boolean;

var summe, dreier : integer;
    flag, vierer  : boolean;

begin

  pardreier:=false;
  vierer:=false;
  flag:=false;

  if (y>1) and (feld[x,y-1]=0) then begin
    feld[x,y-1]:=wer;
    suche(summe,dreier,vierer,x,y-1,feld,wer);
    feld[x,y-1]:=0;
    flag:=vierer;
  end
  else flag:=false;

  if (feld[x,y]=0) then begin
    feld[x,y]:=wer;
    suche(summe,dreier,vierer,x,y,feld,wer);
    feld[x,y]:=0;
    if vierer and flag then pardreier:=true;
    flag:=vierer;
  end
  else flag:=false;

  if (y<ymax) and (feld[x,y+1]=0) then begin
    feld[x,y+1]:=wer;
    suche(summe,dreier,vierer,x,y+1,feld,wer);
    feld[x,y+1]:=0;
    if vierer and flag then pardreier:=true;
  end;

end;

(* testen, ob Parallel-Zugzwang-Dreier *)

function check(feld : spielbrett; wer, x : integer):boolean;

var a, b, y      : integer;
    flagr, flagl : boolean;

begin

  y:=ziehe(feld,x,wer);

  flagr:=false; flagl:=false;

  (* Horizontale *)

  if (y<>0) then begin
    a:=-1;
    repeat
      inc(a);
    until ((x+a)=xmax) or (feld[x+a,y]<>wer);
    b:=-1;
    repeat
      inc(b);
    until ((x-b)=1) or (feld[x-b,y]<>wer);

    if (feld[x+a,y]=0) then flagr:=pardreier(feld,wer,x+a,y);
    if (feld[x-b,y]=0) then flagl:=pardreier(feld,wer,x-b,y);

    (* Diagonale 1, luro *)

    a:=-1;
    repeat
      inc(a);
    until ((x+a)=xmax) or ((y+a)=ymax) or (feld[x+a,y+a]<>wer);
    b:=-1;
    repeat
      inc(b);
    until ((x-b)=1) or ((y-b)=1) or (feld[x-b,y-b]<>wer);

    if (feld[x+a,y+a]=0) then flagr:=pardreier(feld,wer,x+a,y+a);
    if (feld[x-b,y-b]=0) then flagl:=pardreier(feld,wer,x-b,y-b);

    (* Diagonale 2, loru *)

    a:=-1;
    repeat
      inc(a);
    until ((x+a)=xmax) or ((y-a)=1) or (feld[x+a,y-a]<>wer);
    b:=-1;
    repeat
      inc(b);
    until ((x-b)=1) or ((y+b)=ymax) or (feld[x-b,y+b]<>wer);

    if (feld[x+a,y-a]=0) then flagr:=pardreier(feld,wer,x+a,y-a);
    if (feld[x-b,y+b]=0) then flagl:=pardreier(feld,wer,x-b,y+b);

    if flagl or flagr then check:=true else check:=false;
  end
  else
    check:=false;
end;

(* Zugzwang-Analysator *)

function zugzwang(wer : integer; var feld : spielbrett; zugx, phase, depth : integer; var endrek : integer):integer;

var zzz, zz, a, b, ry, x, xphase : integer;
    ya, summe, dreier, typ, rek  : integer;
    vierer                       : boolean;
    bewe                         : bewertung;

begin

  vierer:=false;
  zz:=-1; rek:=-1;
  inc(phase);
  xphase:=-1;

  ya:=ziehe(feld,zugx,wer);
  if (ya=0) then zz:=0;

  ry:=ready(feld);

  if (ry=1) or (ry=2) then begin zz:=ry; rek:=ry; end;
  if (ry=3)           then begin zz:=0;  rek:=0;  end;
  if (ry<>0)          then xphase:=phase;

  if (zz=-1) and ((phase<depth) or (depth=-1)) then begin
    zz:=0;

    if (wer=2) then begin
      for typ:=1 to 2 do
        for x:=1 to xmax do begin
          if (typ=1) then bewe[0,x]:=0;
          a:=ziehe(feld,x,typ);

          if (a<>0) then begin
            bewerte(summe,dreier,vierer,x,a,feld,typ);
            entnehme(feld,x);

            if vierer and (typ=1) then begin
              rek:=1; zz:=1;
              xphase:=phase+1;
            end;

            if ((dreier=0) or (dreier=1) or (dreier=4)) and (typ=1) then bewe[0,x]:=1;

            zzz:=0;
            if vierer and (typ=2) and (zz=0) then
              zzz:=zugzwang(1,feld,x,phase,depth,endrek);
            if (zzz=2) then zz:=2;
            if (zzz=1) then if (zz=0) then zz:=1;
          end;
      end;
                           (* kann der Gegner mich zwingen ?    *)
      if (zz=0) then begin (* absolut keine Zugzwangmglichkeit *)
        for x:=1 to xmax do begin
          if (bewe[0,x]=1) then begin
            zzz:=0;
            zzz:=zugzwang(1,feld,x,phase,depth,endrek);
            if (zzz=1) then zz:=1; (* der Gegner kann mich fertig machen ! *)
          end;
        end;
      end;
    end
    else begin
      for typ:=2 downto 1 do
        for x:=1 to xmax do begin
          if (typ=2) then bewe[0,x]:=0;
          a:=ziehe(feld,x,typ);

          if (a<>0) then begin
            bewerte(summe,dreier,vierer,x,a,feld,typ);
            entnehme(feld,x);

            if vierer and (typ=2) then begin
               rek:=2; zz:=2;
               xphase:=phase+1;
            end;

            if ((dreier=0) or (dreier=1) or (dreier=4)) and (typ=2) then bewe[0,x]:=1;

            zzz:=0;
            if vierer and (typ=1) and (zz=0) then
              zzz:=zugzwang(2,feld,x,phase,depth,endrek);
            if (zzz=1) then zz:=1;
            if (zzz=2) then if (zz=0) then zz:=2;
          end;
      end;

      if (zz=0) then begin
        for x:=1 to xmax do begin
          if (bewe[0,x]=1) then begin
            zzz:=0;
            zzz:=zugzwang(2,feld,x,phase,depth,endrek);
            if (zzz=2) then zz:=2;
          end;
        end;
      end;
    end;
  end;

  zugzwang:=zz;
  if (rek<>-1) then if
    (endrek=-1) or (xphase<endrek) then endrek:=xphase;

  if (ya<>0) then entnehme(feld,zugx);

end;

(* generiert den Zug des Computers *)

function comzug(level : integer; feld : spielbrett; wer : integer):integer;

var endrek1, endrek2, depth : integer;
    zugx, x, a, b, t        : integer;
    setf, flag, c, d        : boolean;

    bewe : array[1..2] of bewertung;

begin

  if info then begin
    clrscr;
    writeln;
    writeln(" Analyzing situation... Please wait...");
    write(" Player: ",wer," = ");
    if (wer=1) then writeln("'yellow'. Level: ",level+1);
    if (wer=2) then writeln("'blue'. Level: ",level+1);
  end;

  for t:=1 to 2 do begin
    for x:=1 to xmax do begin
       bewe[t,1,x]:=0; bewe[t,2,x]:=0; bewe[t,0,x]:=-1; end;
    denke(min(level,1),0,1,feld,bewe[t],t);

    (* Info-Text *)

    if info then begin
      writeln; write(" Player ",t,": ");
      for x:=1 to xmax do
        write(x," ",bewe[t,0,x]:2," ",bewe[t,1,x]:3,"|");
    end;
  end;

  zugx:=0;

  (* bewe : Spieler, 0..2, Position. 0: Dreierkennung, 1: Bewertung,
                                     2: Anz. Zuege bis zum Sieg *)
  (* Kann jemand gewinnen? *)

  for x:=1 to xmax do begin
    if (bewe[3-wer,2,x]=1) then zugx:=x;
  end;

  for x:=1 to xmax do begin
    if (bewe[wer,2,x]=1) then zugx:=x;
  end;

  (* Zugzwang-Kontrolle *)

  if (zugx=0) then begin

    case level of
      0 : depth:=1;
      1 : depth:=6;
      2 : depth:=-1;
    end;

    if info then begin writeln; writeln; end;

    for x:=1 to xmax do begin
      if ((level=2) or (bewe[3-wer,2,x]>1) or (bewe[wer,2,x]>1))
         and (feld[x,ymax]=0) then begin

        endrek1:=-1;
        endrek2:=-1;
        a:=zugzwang(wer  ,feld,x,0,depth,endrek1);
        b:=zugzwang(3-wer,feld,x,0,depth,endrek2);
        c:=vorpardreier(feld,x,  wer);
        d:=vorpardreier(feld,x,3-wer);
        if (c or d) and not((a=0) and (b=0)) then begin
          c:=false; d:=false;
        end;

        (* Info-Text *)

        if info then begin

          write(" -> Player ",wer,": If you turn ",x,", winner will be ");
          if (a<>0) then begin
            if (a=wer)   then writeln("you in ",endrek1," moves.");
            if (a=3-wer) then writeln("your opponent in ",endrek1," moves.");
          end
          else begin
            write("no one");
            if (endrek1<>-1) then writeln(" in ",endrek1," moves.") else writeln(".");
          end;

          write("              If your opponent turns ",x,", winner will be ");
          if (b<>0) then begin
            if (b=wer)   then writeln("you in ",endrek2," moves.");
            if (b=3-wer) then writeln("he in ",endrek2," moves.");
          end
          else begin
            write("no one");
            if (endrek2<>-1) then writeln(" in ",endrek2," moves.") else writeln(".");
          end;

        end;

        (* keiner darf ziehen, sonst gewinnt Gegner *)

        if (a=3-wer) and (b=wer) then begin
          bewe[wer,1,x]:=-(4-wer);
          bewe[wer,2,x]:=endrek1;
          bewe[wer,0,x]:=-2;
        end;

        (* die darf ich nicht setzen, tragisch *)

        if ((a=3-wer) and (b=0)) or d then begin
          bewe[wer,1,x]:=-(4-wer);
          bewe[wer,2,x]:=endrek1;
          bewe[wer,0,x]:=-2;
        end;

        (* setzen, Zugzwangkaskade aufbaubar ! *)

        if (a=wer) or c then begin
          bewe[wer,1,x]:=-(wer+1);
          bewe[wer,2,x]:=endrek1;
          bewe[wer,0,x]:=-2;
        end;

        (* wenn ich diesen setze, macht Gegner kaputt *)

        if (a=0) and (b=wer) and (level=2) then begin (* nur setzen, wenn keine andere Mglichkeit *)
          bewe[wer,1,x]:=-4; (* Spezialkennung eingefhrt! *)
          bewe[wer,2,x]:=endrek2;
          bewe[wer,0,x]:=-2;
        end;

        (* verhindern *)

        if (b=3-wer) and (a=0) then begin
          bewe[3-wer,1,x]:=-(4-wer);
          bewe[3-wer,2,x]:=endrek2;
          bewe[3-wer,0,x]:=-2;
        end;

        if (b=3-wer) and (a=3-wer) then begin (* sowieso Hoffnungslos *)
          bewe[wer,1,x]:=-(4-wer);
          bewe[wer,2,x]:=min(endrek2,endrek1);
          bewe[wer,0,x]:=-2;
        end;
      end;
    end;

    (* Zugzwang-Kaskaden ?                 *)
    (* Gegner kann gewinnen -> verhindern! *)

    if info then begin
      writeln;
      writeln(" Tactic thoughts...");
    end;

    zugx:=0; a:=-1; flag:=true;
    t:=xmax*ymax;

    for x:=1 to xmax do
      if (bewe[3-wer,2,x]<=t) and (bewe[3-wer,1,x]=-(4-wer)) then begin
        if (bewe[3-wer,2,x]=t) then begin
          if (bewe[wer,1,x]>a) then zugx:=x;
          a:=bewe[wer,1,x];
          flag:=false;
        end;
        if flag then begin a:=bewe[wer,1,x]; zugx:=x; end;
        t:=bewe[3-wer,2,x];
    end;

    (* Computer gewinnt, Zugzwang f. Gegner *)

    t:=xmax*ymax;
    for x:=1 to xmax do
      if (bewe[wer,2,x]<=t) and (bewe[wer,1,x]=-(wer+1)) then begin
        zugx:=x;
        t:=bewe[wer,2,x];
    end;

    (* keine Kaskaden *)

    if (zugx=0) then begin

      flag:=true;
      for x:=1 to xmax do
        if (bewe[wer,1,x]<>-(4-wer)) and (bewe[wer,1,x]<>-1) then flag:=false;

      (* hoffnungslos? den besten schlechten Zug nehmen, evt. Dummheit des Gegners *)

      if flag then begin
        t:=0;
        for x:=1 to xmax do
          if (bewe[wer,2,x]>=t) and (bewe[wer,1,x]=-(4-wer)) then begin
            zugx:=x;
            t:=bewe[wer,2,x];
        end;
      end;

      if (zugx=0) then begin

        (* hat Gegner Zwickmhlen? nur f. Level 1 ntig *)

        for t:=4 downto 0 do
          if (t=4) or (t=0) then begin
            a:=0;
            for x:=1 to xmax do
              if (bewe[wer,1,x]>=a) and (bewe[3-wer,0,x]=t) then begin
                zugx:=x;
                a:=bewe[wer,1,x];
            end;
        end;

        (* eigenen Zugzwang-Dreier ausspielen *)

        t:=0;
        for x:=1 to xmax do
          if (bewe[wer,1,x]>=t) and (bewe[wer,0,x]=1) then begin
            zugx:=x;
            t:=bewe[wer,1,x];
        end;

        (* eigene Zwickmhle ausspielen *)

        for t:=4 downto 0 do
          if (t=4) or (t=0) then begin
            a:=0;
            for x:=1 to xmax do
              if (bewe[wer,1,x]>=a) and (bewe[wer,0,x]=t) then begin
                zugx:=x;
                a:=bewe[wer,1,x];
            end;
        end;

        (* kann Computer parallelen Zugzwang-Dreier aufbauen? *)

        t:=0; setf:=false;

        if (zugx=0) then
          for x:=1 to xmax do
            if (not setf) and ((level=2) or (bewe[wer,0,x]=2)) then begin
              setf:=check(feld,wer,x);
              if setf and (bewe[wer,1,x]>=t) then begin
                zugx:=x;
                t:=bewe[wer,1,x];
              end;
        end;

        (* Gegner ist nicht im Zugzwang, also evt. par. ZZ-3er des Geg. verh. *)

        t:=0; setf:=false;

        if (zugx=0) then
          for x:=1 to xmax do
            if (not setf) and ((level=2) or (bewe[3-wer,0,x]=2)) then begin
              setf:=check(feld,3-wer,x);
              if setf and (bewe[wer,1,x]>=t) then begin
                zugx:=x;
                t:=bewe[wer,1,x];
              end;
        end;
      end;

      (* keine kritischen Zuege vorhanden !   *)
      (* strategische Analysen starten        *)

      (* vervollstndigbarer Dreier? *)

      if (zugx=0) then begin
        if info then writeln(" Strategic thoughts...");
        t:=0;
        for x:=1 to xmax do
          if (bewe[wer,1,x]>=t) and (bewe[wer,0,x]=2) then begin
            zugx:=x;
            t:=bewe[wer,1,x];
        end;
      end;

      (* Mitte noch frei?, sonst besten Zug nehmen! *)

      if (zugx=0) then begin
        t:=0;
        if (feld[round(xmax/2),ymax]=0) then
          zugx:=round(xmax/2)
        else begin
          for x:=1 to xmax do
            if (bewe[wer,1,x]>=t) then begin
              t:=bewe[wer,1,x];
              zugx:=x;
          end;

          (* kein vernnftiger Zug mehr -> den Gegner rgern! *)

          if (zugx<>0) and (t=0) then begin
            for x:=1 to xmax do
              if (bewe[3-wer,1,x]>=t) then begin
                t:=bewe[3-wer,1,x];
                zugx:=x;
            end;
          end;

        end;
      end;
    end;

    (* Codierung: -1 : Spalte voll, -3 : Gegner gewinnt, -2 : Comp. gewinnt *)
    (* Endspiel: Gegner gewinnt, Gegner zerstrt meinen 3er *)

    if (zugx=0) then begin
      if info then writeln(" Endgame thoughts...");
      for x:=1 to xmax do
        if (bewe[wer,1,x]=-(4-wer)) then zugx:=x;
      for x:=1 to xmax do
        if (bewe[wer,1,x]=-4)       then zugx:=x;
    end;
  end;

  comzug:=zugx;

end;

(* Ablaufsteuerung *)

begin

  clrscr;

  OpenLib(GfxBase,  'graphics.library', 0);
  OpenLib(IntBase, 'intuition.library', 0);

  repeat

    IWin:=Open_Window(230, 34, 176, 192,1, _CLOSEWINDOW or MOUSEBUTTONS,
          GIMMEZEROZERO+ACTIVATE+WINDOWCLOSE+WINDOWDRAG,' Hello! ',
          Nil, 176, 192, 176, 192);

    IRp:=IWin^.RPort;
    Vp:=ViewPortAddress(IWin);

    SetRGB4(Vp,0,0,0,0);
    SetRGB4(Vp,3,6,6,5);
    SetRGB4(Vp,1,3,15,3);
    SetRGB4(Vp,2,5,9,15);

    SetBPen(IRp,0);

    yl:=12;
    text(IRp,'   "Vier Gewinnt!"  ',yl,1);
    text(IRp,'   ---------------  ',yl,3);

    yl:=yl+8;
    text(IRp,'   (C) 4-9/1993 by  ',yl,1);
    text(IRp,'       MW-Soft!     ',yl,1);

    yl:=yl+8;
    text(IRp,'    Choose level:   ',yl,1);
    text(IRp,'    -------------   ',yl,3);
    yl:=yl+8;
    text(IRp,'    1 = ridiculous  ',yl,1);
    text(IRp,'    2 = average     ',yl,1);
    text(IRp,'    3 = hard        ',yl,1);

    SetAPen(IRp,3);

    RectFill(IRp,16,140,64,164);
    RectFill(IRp,96,140,144,164);
    RectFill(IRp,56,108,104,132);
    SetAPen(IRp,1);
    SetBPen(IRp,3);

    GText(IRp,'2',36,155,1,0);
    GText(IRp,'3',116,155,1,0);
    GText(IRp,'1',76,123,1,0);

    repeat
      warte(IWin^.UserPort,i,ii);
    until ((((i>16) and (i<64)) or ((i>96) and (i<144))) and
        (ii>140) and (ii<164)) or
        ((i>56) and (i<104) and (ii>108) and (ii<132));

    Close_Window(IWin);

    if ((i>56) and (i<104) and (ii>108) and (ii<132)) then level:=0;
    if ((i>16) and (i<64) and (ii>140) and (ii<164)) then level:=1;
    if ((i>96) and (i<144) and (ii>140) and (ii<164)) then level:=2;

    Win:= Open_Window(0, 0, 350, 180, 1, _CLOSEWINDOW or NEWSIZE or MOUSEBUTTONS,
          WINDOWSIZING+GIMMEZEROZERO+ACTIVATE+WINDOWCLOSE+WINDOWDRAG+WINDOWDEPTH,
          ' 4 Gewinnt! ', Nil, 350, 180, 640, 256);

    Rp:= Win^.RPort;

    plane:=Ptr(AllocRaster(640,256));
    InitTmpRas(^TRas,plane,RASSIZE(640,256));
    Rp^.TmpRas:=^TRas;

    InitArea(^AEllInf,^EllBuff,2);
    InitArea(^ATriInf,^TriBuff,4);
    Rp^.AreaInfo:=^AEllInf;

    flag:=TRUE;
    ende:=false;
    demo:=false;

    for i:=1 to xmax do
      for ii:=0 to ymax do
        feld[i,ii]:=0;

    werzieht:=2;
    lzug:=0;
    zugzaehl:=0;

    repeat
      repeat

        knopf:=0;
        funktion:=0;

        if flag then begin
          dx:=Win^.Width;
          dy:=Win^.Height;
          brett(feld,dx,dy);
          werzieht:=3-werzieht;
          wechsel(dx,dy,werzieht);
          flag:=false;
          if demo then faerbe(dx,dy,0,5,1);
          faerbe(dx,dy,lzug,0,1);
        end;

        if (not demo) then Msg:= Wait_Port(Win^.UserPort);
        Msg:= Get_Msg(Win^.Userport);

        if (Msg<>Nil) then begin
          if (Msg^.Class=NEWSIZE) then flag:=TRUE;
          if (Msg^.Class=_CLOSEWINDOW) then ende:=true;
          if (Msg^.Class=MOUSEBUTTONS) then
            if (Msg^.Code and $80)=0 then
              if (Msg^.Code and $01)=0 then
                mausknopf(Msg^.MouseX,Msg^.MouseY,dx,dy,knopf,funktion);

          Reply_Msg(Msg);
        end;

      Until demo or ende or (knopf<>0) or (funktion<>0);

      if (knopf<>0) then begin
        y:=ziehe(feld,knopf,werzieht);
        if (y<>0) then begin
          spieler:=werzieht;
          inc(zugzaehl);
          zugmemx[zugzaehl]:=knopf;
          zugmemy[zugzaehl]:=y;
          if (lzug>0) and (lzug<>knopf) then faerbe(dx,dy,lzug,0,2);
          zeigestein(dx,dy,knopf,y,werzieht);
          wechsel(dx,dy,werzieht);
        end
        else
          faerbe(dx,dy,knopf,0,2);
      end;

      if (funktion=5) then demo:=not demo;

      zug:=0;
      if (funktion=1) or demo then begin
        if demo then spieler:=-1 else spieler:=3-werzieht;
        if ((zugzaehl<3) and (level<>2)) then
          zug:=random(xmax-2)+2
        else
          zug:=comzug(level,feld,werzieht);
        y:=ziehe(feld,zug,werzieht);
        inc(zugzaehl);
        zugmemx[zugzaehl]:=zug;
        zugmemy[zugzaehl]:=y;
        if (lzug>0) and (lzug<>zug) then faerbe(dx,dy,lzug,0,2);
        faerbe(dx,dy,zug,0,1);
        zeigestein(dx,dy,zug,y,werzieht);
        wechsel(dx,dy,werzieht);
      end;

      if (funktion=2) and (zugzaehl>0) then begin
        knopf:=zugmemx[zugzaehl];
        y:=zugmemy[zugzaehl];
        entnehme(feld,knopf);
        if (lzug>0) and (lzug<>zug) then faerbe(dx,dy,lzug,0,2);
        zeigestein(dx,dy,knopf,y,0);
        faerbe(dx,dy,knopf,0,1);
        wechsel(dx,dy,werzieht);
        dec(zugzaehl);
      end;

      if (funktion=3) then wechsel(dx,dy,werzieht);

      if (funktion=4) then begin
        flag:=True;
        for i:=1 to xmax do
          for ii:=0 to ymax do
            feld[i,ii]:=0;

        werzieht:=2;
        zugzaehl:=0;
      end;

      if (funktion=6) then begin
        IWin:=Open_Window(230, 34, 176, 192,1, _CLOSEWINDOW or MOUSEBUTTONS,
              GIMMEZEROZERO+ACTIVATE+WINDOWCLOSE+WINDOWDRAG,' Informations: ',
              Nil, 176, 192, 176, 192);

        IRp:=IWin^.RPort;
        SetBPen(IRp,0);

        yl:=20;
        text(IRp,'   "Vier Gewinnt!"  ',yl,1);
        text(IRp,'   ---------------  ',yl,3);

        yl:=yl+8;
        text(IRp,'   (C) 4-9/1993 by  ',yl,1);
        text(IRp,'   Michael Wessel,  ',yl,1);
        text(IRp,'  Hamburg-Niendorf. ',yl,1);

        yl:=yl+8;
        text(IRp,'     Written in     ',yl,2);
        text(IRp,'   Kick-Pascal 2.1. ',yl,2);
        yl:=yl+8;
        text(IRp,'   This program is  ',yl,1);
        text(IRp,' PUBLIC DOMAIN! Copy',yl,1);
        text(IRp,' it freely and have ',yl,1);
        text(IRp,'    nice games...   ',yl,1);

        SetAPen(IRp,3);
        RectFill(IRp,16,140,64,164);
        RectFill(IRp,96,140,144,164);

        GText(IRp,'More',24,151,1,0);
        GText(IRp,'Infos',20,159,1,0);
        GText(IRp,'OK!',108,155,1,0);

        repeat
          warte(IWin^.UserPort,i,ii);
        until (((i>16) and (i<64)) or ((i>96) and (i<144)))
              and (ii>140) and (ii<164);

        if (i<64) then begin

          SetRast(IRp,0);
          SetBPen(IRp,0);

          yl:=20;
          text(IRp,'     Functions:     ',yl,1);
          text(IRp,'     ----------     ',yl,3);
          yl:=yl+8;
          text(IRp,'   Use the mouse!   ',yl,2);
          text(IRp,' Move: comp. moves  ',yl,1);
          text(IRp,' Back: undo last mv.',yl,1);
          text(IRp,' <-->: change colors',yl,1);
          text(IRp,' New!: new game     ',yl,1);
          text(IRp,' Demo: show demo    ',yl,1);
          text(IRp,' Info: show infos   ',yl,1);
          yl:=yl+8;
          text(IRp,'  To move click on  ',yl,2);
          text(IRp,' triangle at top of ',yl,2);
          text(IRp,'    specific row.   ',yl,2);

          SetAPen(IRp,3);
          RectFill(IRp,16,140,64,164);
          RectFill(IRp,96,140,144,164);

          GText(IRp,'OK!',28,155,1,0);
          GText(IRp,'OK!',108,155,1,0);

          repeat
            Msg:=Wait_Port(IWin^.UserPort);
            Msg:=Get_Msg(IWin^.UserPort);
            Reply_Msg(Msg);

          until (Msg^.Class=MOUSEBUTTONS) and ((Msg^.Code and $80)=0)
                and ((Msg^.Code and $01)=0);
        end;

        Close_Window(IWin);
      end;

      if (y<>0) then if knopf<>0 then lzug:=knopf;
      if (zug<>0) then lzug:=zug;

      if (not demo) and (funktion<>0) then faerbe(dx,dy,0,funktion,2);
      fertig:=ready(feld);
    until ende or (fertig<>0);

    IWin:=Open_Window(360, 34, 176, 192,1, _CLOSEWINDOW or MOUSEBUTTONS,
                      GIMMEZEROZERO+ACTIVATE+WINDOWCLOSE+WINDOWDRAG,' Hey, read this!',
                      Nil, 176, 192, 176, 192);

    IRp:=IWin^.RPort;
    yl:=20;
    SetBPen(IRp,0);

    if not ende then begin

      text(IRp,'    ! Game Over !   ',yl,1);
      text(IRp,'   ---------------  ',yl,3);

      yl:=yl+16;
      text(IRp,'   The winner is:   ',yl,1);
      yl:=yl+8;
      if (fertig=3)          then text(IRp,'    !! NO ONE !!    ',yl,2);
      if (fertig=spieler)    then text(IRp,'     !! YOU !!      ',yl,2);
      if (fertig=3-spieler)  then text(IRp,' !! THE COMPUTER !! ',yl,2);
      if (fertig=1) and demo then text(IRp,'    !! YELLOW !!    ',yl,2);
      if (fertig=2) and demo then text(IRp,'     !! BLUE !!     ',yl,2);

      yl:=yl+16;
      text(IRp,'   Would you like   ',yl,1);
      text(IRp,'  one more game or  ',yl,1);
      text(IRp,'   will you leave   ',yl,1);
      text(IRp,' "4 Gewinnt" (Y/N)? ',yl,1);

    end
    else begin
      text(IRp,'  Quit "4 Gewinnt!" ',yl,1);
      text(IRp,'  ----------------- ',yl,3);
      yl:=yl+8;
      text(IRp,'          ?         ',yl,1);
      text(IRp,'         ? ?        ',yl,2);
      text(IRp,'        ? ? ?       ',yl,3);
      yl:=yl+8;
      text(IRp,'    Do you really   ',yl,1);
      text(IRp,'    want to leave   ',yl,1);
      text(IRp,'     "4 Gewinnt"    ',yl,1);
      yl:=yl+8;
      text(IRp,'        ? ? ?       ',yl,3);
      text(IRp,'         ? ?        ',yl,2);
      text(IRp,'          ?         ',yl,1);
    end;

    SetAPen(IRp,3);
    RectFill(IRp,16,140,64,164);
    RectFill(IRp,96,140,144,164);

    if ende then begin
      GText(IRp,'Yes',108,155,1,0)
      GText(IRp,'No',32,155,1,0);
    end
    else begin
       GText(IRp,'Yes',28,155,1,0);
       GText(IRp,'No',112,155,1,0);
    end;

    i:=0; ii:=0;
    repeat
      warte(IWin^.UserPort,i,ii);
    until (((i>16) and (i<64)) or ((i>96) and (i<144)))
           and (ii>140) and (ii<164);

    if (i<64) then ende:=false else ende:=true;

    Close_Window(IWin);
    Close_Window(Win);
    FreeRaster(plane,640,256);

  until ende;

end.
















